package ru.vsu.cs.course3.compiler;

import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.Reader;

import org.antlr.v4.runtime.CharStream;
import org.antlr.v4.runtime.CharStreams;
import org.antlr.v4.runtime.CommonTokenStream;
import ru.vsu.cs.course3.compiler.ast.AstNode;
import ru.vsu.cs.course3.compiler.parse.ParseTreeToAstTransformer;
import ru.vsu.cs.course3.compiler.parse.ParserLexer;
import ru.vsu.cs.course3.compiler.parse.ParserParser;


public class Program {
    public static void main(String[] args) throws Exception {
        Reader input = args.length > 0 ? new FileReader(args[0]) : new InputStreamReader(System.in);
        ParserLexer lexer = new ParserLexer(CharStreams.fromReader(input));
        ParserParser parser = new ParserParser(new CommonTokenStream(lexer));
        var parseTree = parser.program();
        AstNode result = (AstNode) new ParseTreeToAstTransformer().visit(parseTree);

//        Parser parser = new Parser(input);
//        AstNode result = parser.start();
        result.printTree(System.out);
    }
}
