package ru.vsu.cs.course3.compiler.ast;

import java.util.*;

public class FuncDeclNode implements ExprNode, StmtNode {
    private ExprNode type = null;
    private IdentNode name = null;
    private List<VarsDeclNode> params = null;
    private StmtNode body = null;

    public FuncDeclNode(ExprNode type, IdentNode name, List<VarsDeclNode> params, StmtNode body) {
        this.type = type;
        this.name = name;
        this.params = params;
        this.body = body;
    }

    @Override
    public Collection<? extends AstNode> childs() {
        List<AstNode> r = new ArrayList<>(params);
        r.add(body);
        return r;
    }

    @Override
    public String toString() {
        return type + " " + name + "(...)";
    }

    public ExprNode getType() {
        return type;
    }

    public IdentNode getName() {
        return name;
    }

    public List<VarsDeclNode> getParams() {
        return params;
    }

    public StmtNode getBody() {
        return body;
    }
}